//-------------------------------------------------------------------//
//                                                                   //
//  RInfo Copyright (C) Glenn Rosenthal, 1998.  All rights reserved. //
//                                                                   //   
//  The KANJISTK.DAT file this program extracts information from was //
//  generated by KINFO.EXE from KANJIDIC compiled by Jim Breen, who  //
//  holds the copyright on it.                                       //
//                                                                   //
//  The radical lookup tables used were originally developed by      //
//  Michael Raine and Derc Yamasaki.                                 //
//                                                                   //
//-------------------------------------------------------------------//

typedef unsigned short ushort;      // Convenient definitions.
typedef unsigned char  byte;
typedef unsigned short KANJI;

//
//  This struture describes an index entry in either the radical info
//  or the stroke info table.  The entry simply contains the number 
//  of kanji to read, and the location of the first kanji.
//
typedef struct radical_info {
  ushort offset;        // Offset from the beginning of the file (in bytes).
  short  count;         // Number of kanji to read.
} radical_info;

//
//  Allocation sizes used for the data_file structure.
//
#define NUMBER_KANJI    (1 << 15)   // Kanji of the entrie file.
#define NUMBER_INFO     300         // 241 radicals, and 30 for count (300 is plenty).
#define NUMBER_STROKE   (1 << 15)   // This is to read the KANJISTK.DATA producec by KINFO.EXE

//
//  This structure describes a data file.  The type of data file read
//  is determined by what fields in the union are accessed.  The fields 
//  are fixed allocation so that the can be browsed in memory easily 
//  using a debugger.
//
typedef struct data_file {
  int size;                             // Size.  Intially bytesize, but is leter adjusted to be data element size.
  union {
    KANJI        kanji [NUMBER_KANJI ]; // Kanji, used to access kanji data files (RADKANJI.DAT & STROKNJI.DAT).
    radical_info info  [NUMBER_INFO  ]; // Info structure used to access index files (RADKANJI.IDX & STROKNJI.IDX).
    byte         stroke[NUMBER_STROKE]; // Stroke count information, used to addess KANJISRK.DAT.
  };
} data_file;
