//
//  JWPce Update untility for version 1.33 copyright (c) 2000, glenn rosenthal, all rights reserved.
//
//  Update utility for JWPce version 1.33.  This utility will convert older format
//  user kana->kanji conversion files to the the format used by JWPce 1.33.
//
//  Older conversion file format:
//
//      <kana-key><TAB><verb-code><TAB><kanji><CR><LF>
//
//  New conversion file format:
//
//      <kana-key><verb_code><kanji><NL>
//
//  Parts fo the file:
//
//      kana-key  -- Kana stored as single byte, with high bit set.
//      verb-code -- Indicates part of speach:
//                      * -- Noun
//                      1 -- Ichi-dan verb (only used in new format)
//                      ukgsztdhpfnrym -- Indicates form of go-dan verb
//      kanji     -- Kanji stored as EUC, with ascii / between conversions.
//

#include <windows.h>
#include <stdio.h>

//
//  This routine checks for the existance of a file.
//
//      name   -- Name of file to check.
//
//      RETURN -- A non-zero return indicates the file exits.
//
static int exists (TCHAR *name) {
  long atrib;
  atrib = GetFileAttributes(name);
  if (atrib == -1) return (false);
  return (true);
}

//
//  Main routine.
//
int WINAPI WinMain (HINSTANCE instance,HINSTANCE prev_instance,TCHAR *command, int show) {
  int   i;
  FILE *in,*out;
//
//  Intro
//
  i = MessageBox (NULL,TEXT("JWPce Update Utility for versions 1.33.\n")
                       TEXT("Copyright (c) 2000 glenn rosenthal, all rights reserved.\n\n")
                       TEXT("This program will update your user kana->kanji conversion file to the format used by JWPce 1.33."),
                       TEXT("Update to JWPce 1.33"),MB_OKCANCEL | MB_ICONINFORMATION);
  if (i == IDCANCEL) return (true);
//
//  Open the input and output file.
//
  if (exists(TEXT("USER.CNV"))) {
    if (!(in = fopen(TEXT("USER.CNV"),TEXT("rb")))) {
      MessageBox (NULL,TEXT("Could not open the user conversions file (USER.CNV)!"),TEXT("Error!"),MB_OK | MB_ICONERROR);
      return (true);
    }
    if (!(out = fopen(TEXT("USER.CNV-%NEW$"),TEXT("wb")))) {
      MessageBox (NULL,TEXT("Could not open the temporary file (USER.CNV-%NEW$)!"),TEXT("Error!"),MB_OK | MB_ICONERROR);
      fclose (in);
      return (true);
    }
//
//  Process the file
//  
    while (EOF != (i = fgetc(in))) {
      if ((i == '\t') || (i == '\r')) continue;
      fputc (i,out);
    }
    fclose (in);
    fclose (out);
//
//  Delete the old file and rename the new file.
//
    if (remove(TEXT("USER.CNV"))) {
      MessageBox (NULL,TEXT("Unable to delete the old user conversion file (USER.CNV)!"),TEXT("Error!"),MB_OK | MB_ICONERROR);
      return (true);
    }
    if (rename(TEXT("USER.CNV-%NEW$"),TEXT("user.cnv"))) {
      MessageBox (NULL,TEXT("Unable to rename the new user conversion file (USER.CNV-NEW -> user.cnv)!"),TEXT("Error!"),MB_OK | MB_ICONERROR);
      return (true);
    }
  }
//
//  Check for files that may need to be deleted.
//
  if (exists(TEXT("WNN.DCT")) || exists(TEXT("WNN.IDX"))) {
    i = MessageBox (NULL,TEXT("The older versions of the kana->kanji database have been found!\n")
                         TEXT("JWPce no longer uses these files.  Do you want them Deleteed?\n\n")
                         TEXT("(Note: If you are still using JWP you will need to keep these files.)"),
                         TEXT("Delete obsolete files?"),MB_YESNO | MB_ICONWARNING | MB_DEFBUTTON2);
    if (i == IDYES) {
      if (exists(TEXT("WNN.DCT")) && remove(TEXT("WNN.DCT"))) {
        MessageBox (NULL,TEXT("Unable to delete the opsolete conversion dictionary (WNN.DCT)!"),TEXT("Error!"),MB_OK | MB_ICONERROR);
        return (true);
      }
      if (exists(TEXT("WNN.IDX")) && remove(TEXT("WNN.IDX"))) {
        MessageBox (NULL,TEXT("Unable to delete the opsolete conversion index (WNN.IDX)!"),TEXT("Error!"),MB_OK | MB_ICONERROR);
        return (true);
      }
    }
  }
//
//  Done!
//
  MessageBox (NULL,TEXT("JWPce Update Utility done!\n\n")
                   TEXT("The update untility (UPDATE.EXE) is no longer need and you can delete it."),
                   TEXT("Update Done!"),MB_OK | MB_ICONINFORMATION);
  return (false);
}